## xenomai 2.6.2.1

=== examples/Makefile ===
all:
	@find . -mindepth 2 -name Makefile -execdir make \;

clean:
	@find . -depth -mindepth 2 -name Makefile -execdir make clean \; 2>/dev/null || true

=== examples/common/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = hw_direct_io

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --skin=posix --cflags) $(MY_CFLAGS)

LDFLAGS=$(MY_LDFLAGS) -O
LDLIBS=$(shell $(XENOCONFIG) --skin=posix --ldflags)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6 or 3.0
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
VERSION:=$(shell sed 's/VERSION = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== examples/native/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = trivial-periodic sigdebug rtprint

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES =

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CPPFLAGS=$(shell $(XENOCONFIG) --skin=native --cflags) $(MY_CFLAGS)

LDFLAGS=$(MY_LDFLAGS)
LDLIBS=$(shell $(XENOCONFIG) --skin=native --ldflags)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LOADLIBES+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6 or 3.0
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
VERSION:=$(shell sed 's/VERSION = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif

=== ksrc/nucleus/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENO_OPT_NUCLEUS) += xeno_nucleus.o

xeno_nucleus-y := \
	bufd.o heap.o intr.o pod.o registry.o \
	synch.o thread.o timebase.o timer.o sched.o \
	sched-idle.o sched-rt.o

xeno_nucleus-$(CONFIG_XENO_OPT_SCHED_SPORADIC) += sched-sporadic.o
xeno_nucleus-$(CONFIG_XENO_OPT_SCHED_TP) += sched-tp.o

xeno_nucleus-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o
xeno_nucleus-$(CONFIG_XENO_OPT_PIPE) += pipe.o
xeno_nucleus-$(CONFIG_XENO_OPT_MAP) += map.o
xeno_nucleus-$(CONFIG_XENO_OPT_SELECT) += select.o
xeno_nucleus-$(CONFIG_PROC_FS) += vfile.o

# CAUTION: this module shall appear last, so that dependencies may
# exist on initcalls defined by other object files.
xeno_nucleus-y += module.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_OPT_NUCLEUS) := xeno_nucleus.o

list-multi := xeno_nucleus.o

xeno_nucleus-objs := \
	bufd.o heap.o intr.o pod.o registry.o \
	synch.o thread.o timebase.o timer.o sched.o \
	sched-idle.o sched-rt.o

opt_objs-$(CONFIG_XENO_OPT_SCHED_SPORADIC) += sched-sporadic.o
opt_objs-$(CONFIG_XENO_OPT_SCHED_TP) += sched-tp.o

opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += shadow.o
opt_objs-$(CONFIG_XENO_OPT_PIPE) += pipe.o
opt_objs-$(CONFIG_XENO_OPT_MAP) += map.o
opt_objs-$(CONFIG_XENO_OPT_SELECT) += select.o
opt_objs-$(CONFIG_PROC_FS) += vfile.o

xeno_nucleus-objs += $(opt_objs-y)

# CAUTION: this module shall appear last, so that dependencies may
# exist on initcalls defined by other object files.
xeno_nucleus-objs += module.o

export-objs := $(xeno_nucleus-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_nucleus.o: $(xeno_nucleus-objs)
	$(LD) -r -o $@ $(xeno_nucleus-objs)

endif

=== ksrc/arch/blackfin/Makefile ===
obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o switch.o

ifndef CONFIG_SMP
xeno_hal-y += atomic.o
endif

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/generic/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-y := hal.o compat.o

export-objs := $(obj-y)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/powerpc/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o
xeno_hal-$(CONFIG_XENO_HW_FPU) += fpu.o

ifeq ($(CONFIG_PPC64),y)
xeno_hal-$(CONFIG_PPC64) += switch_64.o
else
xeno_hal-$(CONFIG_PPC) += switch_32.o
endif

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal.o
obj-$(CONFIG_XENO_HW_FPU) += fpu.o

ifeq ($(CONFIG_PPC64),y)
obj-y += switch_64.o
else
obj-y += switch_32.o
endif

export-objs := hal.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

EXTRA_AFLAGS += -I$(TOPDIR)/arch/ppc/kernel

include $(TOPDIR)/Rules.make

endif

=== ksrc/arch/sh/Makefile ===

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal.o trampoline.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

=== ksrc/arch/x86/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

ifeq ($(CONFIG_X86_64),y)
X86_MODE := 64
else
X86_MODE := 32
endif

obj-$(CONFIG_XENOMAI) += xeno_hal.o

xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o

xeno_hal-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

USE_STANDARD_AS_RULE := true

O_TARGET := built-in.o

obj-y := hal_32.o hal-common.o

obj-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o

export-objs := $(obj-y) $(obj-m)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

endif

=== ksrc/drivers/serial/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai

obj-$(CONFIG_XENO_DRIVERS_16550A) += xeno_16550A.o
obj-$(CONFIG_XENO_DRIVERS_MPC52XX_UART) += xeno_mpc52xx_uart.o
obj-$(CONFIG_XENO_DRIVERS_IMX_UART) += xeno_imx_uart.o

xeno_16550A-y := 16550A.o
xeno_mpc52xx_uart-y := rt_mpc52xx_uart.o
xeno_imx_uart-y := rt_imx_uart.o

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_DRIVERS_16550A) := xeno_16550A.o

xeno_16550A-objs := 16550A.o

export-objs := $(xeno_16550A-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat

include $(TOPDIR)/Rules.make

xeno_16550A.o: $(xeno_16550A-objs)
	$(LD) -r -o $@ $(xeno_16550A-objs)

endif

=== ksrc/skins/posix/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENO_SKIN_POSIX) += xeno_posix.o

xeno_posix-y := sched.o thread_attr.o thread.o mutex_attr.o mutex.o \
		cond_attr.o cond.o sem.o cancel.o once.o signal.o tsd.o \
		clock.o timer.o registry.o mq.o module.o apc.o

xeno_posix-$(CONFIG_XENO_OPT_POSIX_SHM) += shm.o

xeno_posix-$(CONFIG_XENO_OPT_POSIX_INTR) += intr.o

xeno_posix-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(srctree)/include/xenomai/posix -I$(src)/.. -Iinclude/xenomai

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_POSIX) := xeno_posix.o

list-multi := xeno_posix.o

xeno_posix-objs := sched.o thread_attr.o thread.o mutex_attr.o mutex.o \
		cond_attr.o cond.o sem.o cancel.o once.o signal.o tsd.o \
		clock.o timer.o registry.o mq.o module.o apc.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

opt_objs-$(CONFIG_XENO_OPT_POSIX_SHM) += shm.o

opt_objs-$(CONFIG_XENO_OPT_POSIX_INTR) += intr.o

xeno_posix-objs += $(opt_objs-y)

export-objs := $(xeno_posix-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I.. -I$(TOPDIR)/include/xenomai/posix

include $(TOPDIR)/Rules.make

xeno_posix.o: $(xeno_posix-objs)
	$(LD) -r -o $@ $(xeno_posix-objs)

endif

=== ksrc/skins/rtdm/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENO_SKIN_RTDM) += xeno_rtdm.o

xeno_rtdm-y := core.o device.o drvlib.o module.o

xeno_rtdm-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o

xeno_rtdm-$(CONFIG_PROC_FS) += proc.o

EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai -I$(src)/..

else

# Makefile frag for Linux v2.4

O_TARGET := built-in.o

obj-$(CONFIG_XENO_SKIN_RTDM) := xeno_rtdm.o

list-multi := xeno_rtdm.o

xeno_rtdm-objs := core.o device.o drvlib.o module.o

opt_objs-y :=
opt_objs-$(CONFIG_XENO_OPT_PERVASIVE) += syscall.o
opt_objs-$(CONFIG_PROC_FS) += proc.o

xeno_rtdm-objs += $(opt_objs-y)

export-objs := $(xeno_rtdm-objs)

EXTRA_CFLAGS += -D__IN_XENOMAI__ -I$(TOPDIR)/include/xenomai -I$(TOPDIR)/include/xenomai/compat -I..

include $(TOPDIR)/Rules.make

xeno_rtdm.o: $(xeno_rtdm-objs)
	$(LD) -r -o $@ $(xeno_rtdm-objs)

endif

=== debian/changelog ===
xenomai (2.6.2.1-2ubuntu2) saucy; urgency=low

  * Do not strip the testsuite. Should work-around a build failure.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 08 Jun 2013 18:41:52 +0400

xenomai (2.6.2.1-2ubuntu1) saucy; urgency=low

  * Merge from Debian unstable. (LP: #1186588) Remaining changes:
    - debian/rules: Set OMAP3 as default target machine as that is
      the closest to what we support from what upstream configure script
      has to offer.
    - debian/control: Add Breaks on udev to get correct version.
    - debian/libxenomai1.preinst: Remove symlink on upgrade, remove old udev.
      rule unless modified in which case move to new name.
    - debian/libxenomai1.postinst: Do not create symlink.
    - debian/libxenomai1.postrm: No symlink to remove.
  * fix_thumb_build.patch no more nedded as it reguarded a previous
      /include/asm-arm/atomic.h version.

 -- Alessandro Losavio <alessandro.losavio@yahoo.com>  Thu, 06 Jun 2013 20:16:03 +0100

xenomai (2.6.2.1-2) unstable; urgency=low

  * debian/control: Standards-Version: 3.9.4
  * debian/compat: 9
  * Fix build on powerpcspe by patching upstream
  * Malfunction of FD_ISSET with RTDM is fixed upstream, thanks
    to Alexandre Duch and Gilles Chanteperdrix (Closes: #695657)

 -- Roland Stigge <stigge@antcom.de>  Thu, 09 May 2013 18:31:31 +0200

xenomai (2.6.2.1-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sat, 26 Jan 2013 15:07:20 +0100

xenomai (2.6.2-1) experimental; urgency=low

  * New upstream release
  * Added powerpcspe to list of supported architectures

 -- Roland Stigge <stigge@antcom.de>  Thu, 27 Dec 2012 13:08:39 +0100

xenomai (2.6.1-git20121216-1) experimental; urgency=low

  * New upstream pre-release

 -- Roland Stigge <stigge@antcom.de>  Sun, 16 Dec 2012 11:44:21 +0100

xenomai (2.6.1-2) experimental; urgency=low

  * Removed obsolete Debian patches
  * Include newer ipipe patches into binary package

 -- Roland Stigge <stigge@antcom.de>  Mon, 13 Aug 2012 14:43:44 +0200

xenomai (2.6.1-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 02 Aug 2012 17:40:54 +0200

=== debian/control ===
Source: xenomai
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 9), findutils (>= 4.2.28), autotools-dev, autoconf, automake, libtool
Standards-Version: 3.9.4
Homepage: http://www.xenomai.org/

Package: xenomai-runtime
Section: devel
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Xenomai runtime utilities
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the runtime programs and the testsuite for the Xenomai
 realtime system.

Package: linux-patch-xenomai
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Suggests: xenomai, linux-source-2.6, kernel-package
Description: Linux kernel patches for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains patches for 2.6 series kernels - These are intended for
 use with kernel-package and a virgin Linux source tree. Note: These patches
 include the base adeos-ipipe patch along with all the additional material
 normally added by the prepare-kernel.sh script.
 .
 This package contains the following patches:
 .

Package: libxenomai1
Section: libs
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Breaks: udev (<< 136-1)
Description: Shared libraries for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains the shared libraries.

Package: libxenomai-dev
Section: libdevel
Architecture: amd64 arm armeb armel i386 powerpc powerpcspe
Depends: libxenomai1 (= ${binary:Version}), ${misc:Depends}
Suggests: linux-patch-xenomai, xenomai-doc
Replaces: xenomai
Conflicts: xenomai
Description: Headers and static libs for Xenomai
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 This package contains development files (header files), the static libraries
 and scripts used to compile realtime applications.

Package: xenomai-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: xenomai
Conflicts: xenomai-docs
Replaces: xenomai-docs
Description: Xenomai documentation
 Xenomai is a real-time development framework cooperating with the Linux
 kernel in order to provide a pervasive, interface-agnostic, hard real-time
 support to user-space applications, seamlessly integrated into the GNU/Linux
 environment. Xenomai provides its own API and emulation layers ("skins") to
 make migration from other RTOS easier. Examples are: pSOS+, VxWorks, VRTX,
 uiTRON, RTAI, POSIX.
 .
 Documentation for Xenomai realtime API.

=== debian/rules ===
#!/usr/bin/make -f

# Author: Paul Corner <paul_c@gna.org>
# Created on: Sat Mar 3 12:00 GMT 2007
# License: GPL Ver. 2

#export DH_VERBOSE=1

DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE=$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

ifeq ($(DEB_HOST_ARCH), i386)
# Note: Would like to use --includedir=/usr/include/xenomai, but
# there appears to be a `make install` problem.
	CONFIG_OPTS = \
	            --enable-x86-tsc
endif
ifeq ($(DEB_HOST_ARCH), amd64)
	CONFIG_OPTS = \
	            --enable-x86-tsc \
	            --enable-x86-sep
endif
ifeq ($(DEB_HOST_ARCH), powerpc)
	CONFIG_OPTS =
endif
ifeq ($(DEB_HOST_ARCH), armeb)
	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), armel)
	CONFIG_OPTS = --enable-arm-mach=omap3 --enable-arm-eabi
endif
ifeq ($(DEB_HOST_ARCH), arm)
	CONFIG_OPTS = --enable-arm-mach=generic
endif
	CONFIG_OPTS += --prefix=/usr \
	            --includedir=/usr/include/xenomai \
	            --mandir=/usr/share/man \
		    --with-testdir=/usr/lib/xenomai

ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
	CONFIG_OPTS += --build $(DEB_BUILD_GNU_TYPE)
endif

# necessary from GCC 4.6 on
CFLAGS += -fno-omit-frame-pointer

build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: config.status xenomai-patch-stamp
	dh_testdir
	$(MAKE)
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: config.status
	dh_testdir
	touch build-indep-stamp

xenomai-patch-stamp:
	dh_testdir
	for i in arm i386 powerpc x86_64 x86 ; do \
		bash $(CURDIR)/scripts/prepare-patch.sh $$i ; \
	done
	touch xenomai-patch-stamp

config.status: configure-stamp
configure-stamp:
	dh_testdir
	autoreconf -fi
	./configure $(CONFIG_OPTS) --with-testdir=/usr/lib/xenomai/testsuite \
		CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" CPPFLAGS="$(CPPFLAGS)"
	touch configure-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f configure-stamp xenomai-patch-stamp build-indep-stamp build-arch-stamp
	-if test -f Makefile ; then \
	    $(MAKE) distclean ; \
	fi
	dh_clean
	rm -fR $(CURDIR)/tmp
	rm -f $(CURDIR)/*.patch
	rm -f include/asm-x86/ipipe/Makefile.in
	-rm -f configure

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp/
	dh_install --sourcedir=$(CURDIR)/debian/tmp
	# Patch collection:
	cp *ipipe-*.patch $(CURDIR)/debian/linux-patch-xenomai/usr/src/kernel-patches/diffs/xenomai
	# xeno-config should be only in libxenomai-dev
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/bin/xeno-config
	rm -f $(CURDIR)/debian/xenomai-runtime/usr/share/man/man1/xeno-config.1
	: > $(CURDIR)/debian/libxenomai1.udev
	for f in $(CURDIR)/ksrc/nucleus/udev/*.rules ; do \
	    cat $$f >> $(CURDIR)/debian/libxenomai1.udev ; \
	done
	install -m 644 debian/libxenomai1.modprobe $(CURDIR)/debian/libxenomai1/etc/modprobe.d/xenomai.conf
	# remove empty directory
	rm -rf $(CURDIR)/debian/xenomai-doc/usr/share/doc/xenomai-doc/ps
	cp debian/libxenomai1.lintian $(CURDIR)/debian/libxenomai1/usr/share/lintian/overrides/libxenomai1
	cp debian/libxenomai-dev.lintian $(CURDIR)/debian/libxenomai-dev/usr/share/lintian/overrides/libxenomai-dev
	# remove *.la files
	rm $(CURDIR)/debian/libxenomai-dev/usr/lib/*.la

# Build architecture-independent files here.
binary-indep: build install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_link -i
	dh_installchangelogs -i
	dh_strip -i
	dh_compress -i -X.pdf $(CURDIR)/debian/linux-patch-xenomai/usr/src/kernel-patches/diffs/xenomai/*
	dh_fixperms -i
	dh_makeshlibs -i
	dh_installdeb -i
	dh_shlibdeps -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -s
	dh_testroot -s
	dh_installinit -s --name=xenomai
	dh_installman -s
	dh_installdocs -s -A
	dh_installudev
	dh_link -s
	dh_installchangelogs -s
	dh_strip -s -Xtestsuite
	dh_compress -s
	dh_fixperms -s
	dh_makeshlibs -s
	dh_installdeb -s
	dh_shlibdeps -s
	dh_gencontrol -s
#	 Echo config options to control.
	echo " ." >> $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo " Compiled with the following options." >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
	echo "$(CONFIG_OPTS)" | awk '{ for ( i=1 ; i<=NF ; i++ ) print "   "$$i }' >> \
	        $(CURDIR)/debian/libxenomai1/DEBIAN/control
#	 End of hackery.
	dh_md5sums -s
	dh_builddeb -s

# We have nothing to do by default.

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
http://download.gna.org/xenomai/stable/xenomai-(.*)\.tar\.bz2

## xenomai 2.6.3

=== ksrc/arch/x86/Makefile ===
--- 
+++ 
@@ -10,9 +10,7 @@
 
 obj-$(CONFIG_XENOMAI) += xeno_hal.o
 
-xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o
-
-xeno_hal-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o
+xeno_hal-y := hal_$(X86_MODE).o hal-common.o usercopy_$(X86_MODE).o smi.o
 
 EXTRA_CFLAGS += -D__IN_XENOMAI__ -Iinclude/xenomai
 
@@ -24,9 +22,7 @@
 
 O_TARGET := built-in.o
 
-obj-y := hal_32.o hal-common.o
-
-obj-$(CONFIG_XENO_HW_SMI_DETECT) += smi.o
+obj-y := hal_32.o hal-common.o smi.o
 
 export-objs := $(obj-y) $(obj-m)

=== debian/changelog ===
xenomai (2.6.3-2) unstable; urgency=low

  * Add usr/lib/pkgconfig to libxenomai-dev.install (Closes: #729060)

 -- Roland Stigge <stigge@antcom.de>  Fri, 08 Nov 2013 14:49:26 +0100

xenomai (2.6.3-1) unstable; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Thu, 17 Oct 2013 16:00:44 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: xenomai
 Section: devel
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Roland Stigge <stigge@antcom.de>
+Maintainer: Roland Stigge <stigge@antcom.de>
 Build-Depends: debhelper (>= 9), findutils (>= 4.2.28), autotools-dev, autoconf, automake, libtool
 Standards-Version: 3.9.4
 Homepage: http://www.xenomai.org/
@@ -53,7 +52,6 @@
 Suggests: linux-patch-xenomai, xenomai-doc
 Replaces: xenomai
 Conflicts: xenomai
-Breaks: udev (<< 136-1)
 Description: Shared libraries for Xenomai
  Xenomai is a real-time development framework cooperating with the Linux
  kernel in order to provide a pervasive, interface-agnostic, hard real-time

=== debian/rules ===
--- 
+++ 
@@ -34,7 +34,7 @@
 	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
 endif
 ifeq ($(DEB_HOST_ARCH), armel)
-	CONFIG_OPTS = --enable-arm-mach=omap3 --enable-arm-eabi
+	CONFIG_OPTS = --enable-arm-mach=generic --enable-arm-eabi
 endif
 ifeq ($(DEB_HOST_ARCH), arm)
 	CONFIG_OPTS = --enable-arm-mach=generic
@@ -106,9 +106,8 @@
 	# xeno-config should be only in libxenomai-dev
 	rm -f $(CURDIR)/debian/xenomai-runtime/usr/bin/xeno-config
 	rm -f $(CURDIR)/debian/xenomai-runtime/usr/share/man/man1/xeno-config.1
-	: > $(CURDIR)/debian/libxenomai1.udev
 	for f in $(CURDIR)/ksrc/nucleus/udev/*.rules ; do \
-	    cat $$f >> $(CURDIR)/debian/libxenomai1.udev ; \
+	    cat $$f >> $(CURDIR)/debian/libxenomai1/etc/udev/xenomai.rules ; \
 	done
 	install -m 644 debian/libxenomai1.modprobe $(CURDIR)/debian/libxenomai1/etc/modprobe.d/xenomai.conf
 	# remove empty directory
@@ -142,10 +141,9 @@
 	dh_installinit -s --name=xenomai
 	dh_installman -s
 	dh_installdocs -s -A
-	dh_installudev
 	dh_link -s
 	dh_installchangelogs -s
-	dh_strip -s -Xtestsuite
+	dh_strip -s
 	dh_compress -s
 	dh_fixperms -s
 	dh_makeshlibs -s

## xenomai 2.6.4%2Bdfsg

=== ksrc/skins/Makefile ===
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

# Makefile frag for Linux v2.6 and v3.x

obj-$(CONFIG_XENOMAI) += native/ posix/ rtdm/ psos+/ vrtx/ vxworks/ uitron/

else

# Makefile frag for Linux v2.4

subdir-$(CONFIG_XENO_SKIN_NATIVE) += native
subdir-$(CONFIG_XENO_SKIN_POSIX) += posix
subdir-$(CONFIG_XENO_SKIN_RTDM) += rtdm
subdir-$(CONFIG_XENO_SKIN_PSOS) += psos+
subdir-$(CONFIG_XENO_SKIN_VRTX) += vrtx
subdir-$(CONFIG_XENO_SKIN_VXWORKS) += vxworks
subdir-$(CONFIG_XENO_SKIN_UITRON) += uitron

include $(TOPDIR)/Rules.make

endif

=== examples/rtdm/driver-api/Makefile ===
###### CONFIGURATION ######

### List of applications to be build
APPLICATIONS = tut01-skeleton-app tut02-skeleton-app

### Note: to override the search path for the xeno-config script, use "make XENO=..."


### List of modules to be build
MODULES = heartbeat tut01-skeleton-drv tut02-skeleton-drv

### Note: to override the kernel source path, use "make KSRC=..."



###### USER SPACE BUILD (no change required normally) ######
ifeq ($(KERNELRELEASE),)
ifneq ($(APPLICATIONS),)

### Default Xenomai installation path
XENO ?= /usr/xenomai

XENOCONFIG=$(shell PATH=$(XENO):$(XENO)/bin:$(PATH) which xeno-config 2>/dev/null)

### Sanity check
ifeq ($(XENOCONFIG),)
all::
	@echo ">>> Invoke make like this: \"make XENO=/path/to/xeno-config\" <<<"
	@echo
endif


CC=$(shell $(XENOCONFIG) --cc)

CFLAGS=$(shell $(XENOCONFIG) --skin=native --cflags) $(MY_CFLAGS)

LDFLAGS=$(MY_LDFLAGS)
LDLIBS=$(shell $(XENOCONFIG) --skin=native --ldflags) \
	$(shell $(XENOCONFIG) --skin=rtdm --ldflags)

# This includes the library path of given Xenomai into the binary to make live
# easier for beginners if Xenomai's libs are not in any default search path.
LDFLAGS+=-Xlinker -rpath -Xlinker $(shell $(XENOCONFIG) --libdir)

all:: $(APPLICATIONS)

clean::
	$(RM) $(APPLICATIONS) *.o

endif
endif



###### KERNEL MODULE BUILD (no change required normally) ######
ifneq ($(MODULES),)

### Default to sources of currently running kernel
KSRC ?= /lib/modules/$(shell uname -r)/build

OBJS     := ${patsubst %, %.o, $(MODULES)}
CLEANMOD := ${patsubst %, .%*, $(MODULES)}
PWD      := $(shell if [ "$$PWD" != "" ]; then echo $$PWD; else pwd; fi)

### Kernel 2.6 or 3.0
PATCHLEVEL:=$(shell sed 's/PATCHLEVEL = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
VERSION:=$(shell sed 's/VERSION = \(.*\)/\1/;t;d' $(KSRC)/Makefile)
ifneq ($(VERSION).$(PATCHLEVEL),2.4)

obj-m        := $(OBJS)
EXTRA_CFLAGS := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/posix $(ADD_CFLAGS)

all::
	$(MAKE) -C $(KSRC) SUBDIRS=$(PWD) modules

### Kernel 2.4
else

ARCH    ?= $(shell uname -i)
INCLUDE := -I$(KSRC)/include/xenomai -I$(KSRC)/include/xenomai/compat -I$(KSRC)/include/xenomai/posix
CFLAGS  += $(shell $(MAKE) -s -C $(KSRC) CC=$(CC) ARCH=$(ARCH) SUBDIRS=$(PWD) modules) $(INCLUDE)

all:: $(OBJS)

endif

## Target for capturing 2.4 module CFLAGS
modules:
	@echo "$(CFLAGS)"

clean::
	$(RM) $(CLEANMOD) *.o *.ko *.mod.c Module*.symvers Module.markers modules.order
	$(RM) -R .tmp*

endif
